VTK: vtkGenericDataSet Class Reference

| VTK 9.3.1

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkGenericDataSet Class Referenceabstract

defines dataset interface More...

`#include <vtkGenericDataSet.h>`

Inheritance diagram for vtkGenericDataSet:
[legend]
Collaboration diagram for vtkGenericDataSet:
[legend]

## Public Member Functions
virtual vtkIdType | GetNumberOfPoints ()=0
| Return the number of points composing the dataset. More...
virtual vtkIdType | GetNumberOfCells (int dim=-1)=0
| Return the number of cells that explicitly define the dataset. More...
vtkIdType | GetNumberOfElements (int type) override
| Get the number of elements for a specific attribute type (POINT, CELL, etc.). More...
virtual int | GetCellDimension ()=0
| Return -1 if the dataset is explicitly defined by cells of varying dimensions or if there are no cells. More...
virtual void | GetCellTypes (vtkCellTypes *types)
| Get a list of types of cells in a dataset. More...
virtual vtkGenericCellIterator * | NewCellIterator (int dim=-1)=0
| Return an iterator to traverse cells of dimension ‘dim’ (or all dimensions if -1) that explicitly define the dataset. More...
virtual vtkGenericCellIterator * | NewBoundaryIterator (int dim=-1, int exteriorOnly=0)=0
| Return an iterator to traverse cell boundaries of dimension ‘dim’ (or all dimensions if -1) of the dataset. More...
virtual vtkGenericPointIterator * | NewPointIterator ()=0
| Return an iterator to traverse the points composing the dataset; they can be points that define a cell (corner points) or isolated points. More...
virtual int | FindCell (double x[3], vtkGenericCellIterator *&cell, double tol2, int &subId, double pcoords[3])=0
| Locate the closest cell to position ‘x’ (global coordinates) with respect to a tolerance squared ‘tol2’ and an initial guess ‘cell’ (if valid). More...
virtual void | FindPoint (double x[3], vtkGenericPointIterator *p)=0
| Locate the closest point ‘p’ to position ‘x’ (global coordinates). More...
vtkMTimeType | GetMTime () override
| Datasets are composite objects and need to check each part for their modified time. More...
virtual void | ComputeBounds ()=0
| Compute the geometry bounding box. More...
virtual double * | GetBounds ()
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
virtual void | GetBounds (double bounds[6])
| Return the geometry bounding box in global coordinates in the form (xmin,xmax, ymin,ymax, zmin,zmax) in the ‘bounds’ array. More...
virtual double * | GetCenter ()
| Get the center of the bounding box in global coordinates. More...
virtual void | GetCenter (double center[3])
| Get the center of the bounding box in global coordinates. More...
virtual double | GetLength ()
| Return the length of the diagonal of the bounding box. More...
vtkDataSetAttributes * | GetAttributes (int type) override
| Returns the attributes of the data object of the specified attribute type. More...
unsigned long | GetActualMemorySize () override
| Actual size of the data in kibibytes (1024 bytes); only valid after the pipeline has updated. More...
int | GetDataObjectType () override
| Return the type of data object. More...
virtual vtkIdType | GetEstimatedSize ()=0
| Estimated size needed after tessellation (or special operation) More...
virtual vtkGenericAttributeCollection * | GetAttributes ()
| Get the collection of attributes associated with this dataset. More...
virtual void | SetTessellator (vtkGenericCellTessellator *tessellator)
| Set/Get a cell tessellator if cells must be tessellated during processing. More...
virtual vtkGenericCellTessellator * | GetTessellator ()
| Set/Get a cell tessellator if cells must be tessellated during processing. More...
Public Member Functions inherited from vtkDataObject
vtkDataObject * | NewInstance () const
virtual void | Initialize ()
| Restore data object to initial state,. More...
void | ReleaseData ()
| Release data back to system to conserve memory resource. More...
vtkMTimeType | GetUpdateTime ()
| Used by Threaded ports to determine if they should initiate an asynchronous update (still in development). More...
virtual void | CopyInformationFromPipeline (vtkInformation *vtkNotUsed(info))
| Copy from the pipeline information to the data object's own information. More...
virtual void | CopyInformationToPipeline (vtkInformation *vtkNotUsed(info))
| Copy information from this data object to the pipeline information. More...
void | DataHasBeenGenerated ()
| This method is called by the source when it executes to generate data. More...
virtual void | PrepareForNewData ()
| make the output data ready for new data to be inserted. More...
virtual void | ShallowCopy (vtkDataObject *src)
| The goal of the method is to copy the data up to the array pointers only. More...
virtual void | DeepCopy (vtkDataObject *src)
| The goal of the method is to copy the complete data from src into this object. More...
virtual int | GetExtentType ()
| The ExtentType will be left as VTK_PIECES_EXTENT for data objects such as vtkPolyData and vtkUnstructuredGrid. More...
virtual void | Crop (const int *updateExtent)
| This method crops the data object (if necessary) so that the extent matches the update extent. More...
virtual vtkUnsignedCharArray * | GetGhostArray (int type)
| Returns the ghost arrays of the data object of the specified attribute type. More...
virtual vtkFieldData * | GetAttributesAsFieldData (int type)
| Returns the attributes of the data object as a vtkFieldData. More...
virtual int | GetAttributeTypeForArray (vtkAbstractArray *arr)
| Retrieves the attribute type that an array came from. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with this data object. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with this data object. More...
virtual vtkTypeBool | GetDataReleased ()
| Get the flag indicating the data has been released. More...
virtual void | SetFieldData (vtkFieldData *)
| Assign or retrieve a general field data to this data object. More...
virtual vtkFieldData * | GetFieldData ()
| Assign or retrieve a general field data to this data object. More...
void | GlobalReleaseDataFlagOn ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
void | GlobalReleaseDataFlagOff ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkGenericDataSet * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkGenericDataSet * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
Static Public Member Functions inherited from vtkDataObject
static vtkDataObject * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataObject * | SafeDownCast (vtkObjectBase *o)
static vtkInformation * | GetActiveFieldInformation (vtkInformation *info, int fieldAssociation, int attributeType)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and attribute (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) More...
static vtkInformation * | GetNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and name. More...
static void | RemoveNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Remove the info associated with an array. More...
static vtkInformation * | SetActiveAttribute (vtkInformation *info, int fieldAssociation, const char *attributeName, int attributeType)
| Set the named array to be the active field for the specified type (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) and association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetActiveAttributeInfo (vtkInformation *info, int fieldAssociation, int attributeType, const char *name, int arrayType, int numComponents, int numTuples)
| Set the name, array type, number of components, and number of tuples within the passed information object for the active attribute of type attributeType (in specified association, FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetPointDataActiveScalarInfo (vtkInformation *info, int arrayType, int numComponents)
| Convenience version of previous method for use (primarily) by the Imaging filters. More...
static const char * | GetAssociationTypeAsString (int associationType)
| Given an integer association type, this static method returns a string type for the attribute (i.e. More...
static int | GetAssociationTypeFromString (const char *associationName)
| Given a string association name, this static method returns an integer association type for the attribute (i.e. More...
static vtkInformationStringKey * | DATA_TYPE_NAME ()
static vtkInformationDataObjectKey * | DATA_OBJECT ()
static vtkInformationIntegerKey * | DATA_EXTENT_TYPE ()
static vtkInformationIntegerPointerKey * | DATA_EXTENT ()
static vtkInformationIntegerVectorKey * | ALL_PIECES_EXTENT ()
static vtkInformationIntegerKey * | DATA_PIECE_NUMBER ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_PIECES ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_GHOST_LEVELS ()
static vtkInformationDoubleKey * | DATA_TIME_STEP ()
static vtkInformationInformationVectorKey * | POINT_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | CELL_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | VERTEX_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | EDGE_DATA_VECTOR ()
static vtkInformationIntegerKey * | FIELD_ARRAY_TYPE ()
static vtkInformationIntegerKey * | FIELD_ASSOCIATION ()
static vtkInformationIntegerKey * | FIELD_ATTRIBUTE_TYPE ()
static vtkInformationIntegerKey * | FIELD_ACTIVE_ATTRIBUTE ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_COMPONENTS ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_TUPLES ()
static vtkInformationIntegerKey * | FIELD_OPERATION ()
static vtkInformationDoubleVectorKey * | FIELD_RANGE ()
static vtkInformationIntegerVectorKey * | PIECE_EXTENT ()
static vtkInformationStringKey * | FIELD_NAME ()
static vtkInformationDoubleVectorKey * | ORIGIN ()
static vtkInformationDoubleVectorKey * | SPACING ()
static vtkInformationDoubleVectorKey * | DIRECTION ()
static vtkInformationDoubleVectorKey * | BOUNDING_BOX ()
static vtkInformationDataObjectKey * | SIL ()
static vtkDataObject * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataObject * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
static void | SetGlobalReleaseDataFlag (vtkTypeBool val)
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
static vtkTypeBool | GetGlobalReleaseDataFlag ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkGenericDataSet ()
| Constructor with uninitialized bounds (1,-1, 1,-1, 1,-1), empty attribute collection and default tessellator. More...
| ~vtkGenericDataSet () override
Protected Member Functions inherited from vtkDataObject
| vtkDataObject ()
| ~vtkDataObject () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkGenericAttributeCollection * | Attributes
vtkGenericCellTessellator * | Tessellator
double | Bounds [6]
double | Center [3]
vtkTimeStamp | ComputeTime
Protected Attributes inherited from vtkDataObject
vtkFieldData * | FieldData
vtkTypeBool | DataReleased
vtkTimeStamp | UpdateTime
vtkInformation * | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkDataObject | Superclass
| Standard VTK type and print macros. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard VTK type and print macros. More...
static vtkGenericDataSet * | SafeDownCast (vtkObjectBase *o)
| Standard VTK type and print macros. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard VTK type and print macros. More...
vtkGenericDataSet * | NewInstance () const
| Standard VTK type and print macros. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard VTK type and print macros. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard VTK type and print macros. More...

## Additional Inherited Members
Public Types inherited from vtkDataObject
enum | FieldAssociations { FIELD_ASSOCIATION_POINTS , FIELD_ASSOCIATION_CELLS , FIELD_ASSOCIATION_NONE , FIELD_ASSOCIATION_POINTS_THEN_CELLS , FIELD_ASSOCIATION_VERTICES , FIELD_ASSOCIATION_EDGES , FIELD_ASSOCIATION_ROWS , NUMBER_OF_ASSOCIATIONS }
| Possible values for the FIELD_ASSOCIATION information entry. More...
enum | AttributeTypes { POINT , CELL , FIELD , POINT_THEN_CELL , VERTEX , EDGE , ROW , NUMBER_OF_ATTRIBUTE_TYPES }
| Possible attribute types. More...
enum | FieldOperations { FIELD_OPERATION_PRESERVED , FIELD_OPERATION_REINTERPOLATED , FIELD_OPERATION_MODIFIED , FIELD_OPERATION_REMOVED }
| Possible values for the FIELD_OPERATION information entry. More...
typedef vtkObject | Superclass
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

defines dataset interface

In VTK, spatial-temporal data is defined in terms of a dataset. The dataset consists of geometry (e.g., points), topology (e.g., cells), and attributes (e.g., scalars, vectors, etc.) vtkGenericDataSet is an abstract class defining this abstraction.

Since vtkGenericDataSet provides a general interface to manipulate data, algorithms that process it tend to be slower than those specialized for a particular data type. For this reason, there are concrete, non-abstract subclasses that represent and provide access to data more efficiently. Note that filters to process this dataset type are currently found in the VTK/GenericFiltering/ subdirectory.

Unlike the vtkDataSet class, vtkGenericDataSet provides a more flexible interface including support for iterators. vtkGenericDataSet is also designed to interface VTK to external simulation packages without the penalty of copying memory (see VTK/GenericFiltering/README.html) for more information. Thus vtkGenericDataSet plays a central role in the adaptor framework.

Please note that this class introduces the concepts of "boundary cells". This refers to the boundaries of a cell (e.g., face of a tetrahedron) which may in turn be represented as a cell. Boundary cells are derivative topological features of cells, and are therefore never explicitly represented in the dataset. Often in visualization algorithms, looping over boundaries (edges or faces) is employed, while the actual dataset cells may not traversed. Thus there are methods to loop over these boundary cells.

Finally, as a point of clarification, points are not the same as vertices. Vertices refer to points, and points specify a position is space. Vertices are a type of 0-D cell. Also, the concept of a DOFNode, which is where coefficients for higher-order cells are kept, is a new concept introduced by the adaptor framework (see vtkGenericAdaptorCell for more information).

See also
  vtkGenericAdaptorCell vtkDataSet

Definition at line 58 of file vtkGenericDataSet.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkDataObject vtkGenericDataSet::Superclass

Standard VTK type and print macros.

Definition at line 65 of file vtkGenericDataSet.h.

## Constructor & Destructor Documentation

## ◆ vtkGenericDataSet()

vtkGenericDataSet::vtkGenericDataSet | ( |  | ) |
| protected

Constructor with uninitialized bounds (1,-1, 1,-1, 1,-1), empty attribute collection and default tessellator.

## ◆ ~vtkGenericDataSet()

vtkGenericDataSet::~vtkGenericDataSet | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkGenericDataSet::IsTypeOf | ( | const char * | type | ) |
| static

Standard VTK type and print macros.

## ◆ IsA()

virtual vtkTypeBool vtkGenericDataSet::IsA | ( | const char * | type | ) |
| virtual

Standard VTK type and print macros.

Reimplemented from vtkDataObject.

## ◆ SafeDownCast()

static vtkGenericDataSet* vtkGenericDataSet::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard VTK type and print macros.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkGenericDataSet::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard VTK type and print macros.

Reimplemented from vtkDataObject.

## ◆ NewInstance()

vtkGenericDataSet* vtkGenericDataSet::NewInstance | ( |  | ) | const

Standard VTK type and print macros.

## ◆ PrintSelf()

void vtkGenericDataSet::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard VTK type and print macros.

Reimplemented from vtkDataObject.

## ◆ GetNumberOfPoints()

virtual vtkIdType vtkGenericDataSet::GetNumberOfPoints | ( |  | ) |
| pure virtual

Return the number of points composing the dataset.

See NewPointIterator() for more details.

Postcondition
  positive_result: result>=0

## ◆ GetNumberOfCells()

virtual vtkIdType vtkGenericDataSet::GetNumberOfCells | ( | int | dim = `-1` | ) |
| pure virtual

Return the number of cells that explicitly define the dataset.

See NewCellIterator() for more details.

Precondition
  valid_dim_range: (dim>=-1) && (dim<=3)

Postcondition
  positive_result: result>=0

## ◆ GetNumberOfElements()

vtkIdType vtkGenericDataSet::GetNumberOfElements | ( | int | type | ) |
| overridevirtual

Get the number of elements for a specific attribute type (POINT, CELL, etc.).

Reimplemented from vtkDataObject.

## ◆ GetCellDimension()

virtual int vtkGenericDataSet::GetCellDimension | ( |  | ) |
| pure virtual

Return -1 if the dataset is explicitly defined by cells of varying dimensions or if there are no cells.

If the dataset is explicitly defined by cells of a unique dimension, return this dimension.

Postcondition
  valid_range: (result>=-1) && (result<=3)

## ◆ GetCellTypes()

virtual void vtkGenericDataSet::GetCellTypes | ( | vtkCellTypes * | types | ) |
| virtual

Get a list of types of cells in a dataset.

The list consists of an array of types (not necessarily in any order), with a single entry per type. For example a dataset 5 triangles, 3 lines, and 100 hexahedra would result a list of three entries, corresponding to the types VTK_TRIANGLE, VTK_LINE, and VTK_HEXAHEDRON. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Precondition
  types_exist: types!=0

## ◆ NewCellIterator()

virtual vtkGenericCellIterator* vtkGenericDataSet::NewCellIterator | ( | int | dim = `-1` | ) |
| pure virtual

Return an iterator to traverse cells of dimension ‘dim’ (or all dimensions if -1) that explicitly define the dataset.

For instance, it will return only tetrahedra if the mesh is defined by tetrahedra. If the mesh is composed of two parts, one with tetrahedra and another part with triangles, it will return both, but will not return the boundary edges and vertices of these cells. The user is responsible for deleting the iterator.

Precondition
  valid_dim_range: (dim>=-1) && (dim<=3)

Postcondition
  result_exists: result!=0

## ◆ NewBoundaryIterator()

virtual vtkGenericCellIterator* vtkGenericDataSet::NewBoundaryIterator | ( | int | dim = `-1`,
|  | int | exteriorOnly = `0`
| ) |  |
| pure virtual

Return an iterator to traverse cell boundaries of dimension ‘dim’ (or all dimensions if -1) of the dataset.

If ‘exteriorOnly’ is true, only the exterior cell boundaries of the dataset will be returned, otherwise it will return exterior and interior cell boundaries. The user is responsible for deleting the iterator.

Precondition
  valid_dim_range: (dim>=-1) && (dim<=2)

Postcondition
  result_exists: result!=0

## ◆ NewPointIterator()

virtual vtkGenericPointIterator* vtkGenericDataSet::NewPointIterator | ( |  | ) |
| pure virtual

Return an iterator to traverse the points composing the dataset; they can be points that define a cell (corner points) or isolated points.

The user is responsible for deleting the iterator.

Postcondition
  result_exists: result!=0

## ◆ FindCell()

virtual int vtkGenericDataSet::FindCell | ( | double | x[3],
|  | vtkGenericCellIterator *& | cell,
|  | double | tol2,
|  | int & | subId,
|  | double | pcoords[3]
| ) |  |
| pure virtual

Locate the closest cell to position ‘x’ (global coordinates) with respect to a tolerance squared ‘tol2’ and an initial guess ‘cell’ (if valid).

The result consists in the ‘cell’, the ‘subId’ of the sub-cell (0 if primary cell), the parametric coordinates ‘pcoord’ of the position. It returns whether the position is inside the cell or not (boolean). Tolerance is used to control how close the point is to be considered "in" the cell. THIS METHOD IS NOT THREAD SAFE.

Precondition
  not_empty: GetNumberOfCells()>0
  cell_exists: cell!=0
  positive_tolerance: tol2>0

## ◆ FindPoint()

virtual void vtkGenericDataSet::FindPoint | ( | double | x[3],
|  | vtkGenericPointIterator * | p
| ) |  |
| pure virtual

Locate the closest point ‘p’ to position ‘x’ (global coordinates).

Precondition
  not_empty: GetNumberOfPoints()>0
  p_exists: p!=0

## ◆ GetMTime()

vtkMTimeType vtkGenericDataSet::GetMTime | ( |  | ) |
| overridevirtual

Datasets are composite objects and need to check each part for their modified time.

Reimplemented from vtkDataObject.

## ◆ ComputeBounds()

virtual void vtkGenericDataSet::ComputeBounds | ( |  | ) |
| pure virtual

Compute the geometry bounding box.

## ◆ GetBounds() [1/2]

virtual double* vtkGenericDataSet::GetBounds | ( |  | ) |
| virtual

Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax).

The return value is VOLATILE.

Postcondition
  result_exists: result!=0

## ◆ GetBounds() [2/2]

virtual void vtkGenericDataSet::GetBounds | ( | double | bounds[6] | ) |
| virtual

Return the geometry bounding box in global coordinates in the form (xmin,xmax, ymin,ymax, zmin,zmax) in the ‘bounds’ array.

## ◆ GetCenter() [1/2]

virtual double* vtkGenericDataSet::GetCenter | ( |  | ) |
| virtual

Get the center of the bounding box in global coordinates.

The return value is VOLATILE.

Postcondition
  result_exists: result!=0

## ◆ GetCenter() [2/2]

virtual void vtkGenericDataSet::GetCenter | ( | double | center[3] | ) |
| virtual

Get the center of the bounding box in global coordinates.

## ◆ GetLength()

virtual double vtkGenericDataSet::GetLength | ( |  | ) |
| virtual

Return the length of the diagonal of the bounding box.

Postcondition
  positive_result: result>=0

## ◆ GetAttributes() [1/2]

virtual vtkGenericAttributeCollection* vtkGenericDataSet::GetAttributes | ( |  | ) |
| virtual

Get the collection of attributes associated with this dataset.

## ◆ GetAttributes() [2/2]

vtkDataSetAttributes* vtkGenericDataSet::GetAttributes | ( | int | type | ) |
| inlineoverridevirtual

Returns the attributes of the data object of the specified attribute type.

The type may be:

- POINT - Defined in vtkDataSet subclasses.
- CELL - Defined in vtkDataSet subclasses.
- VERTEX - Defined in vtkGraph subclasses.
- EDGE - Defined in vtkGraph subclasses.
- ROW - Defined in vtkTable.

The other attribute type, FIELD, will return nullptr since field data is stored as a vtkFieldData instance, not a vtkDataSetAttributes instance. To retrieve field data, use GetAttributesAsFieldData.

Reimplemented from vtkDataObject.

Definition at line 232 of file vtkGenericDataSet.h.

## ◆ SetTessellator()

virtual void vtkGenericDataSet::SetTessellator | ( | vtkGenericCellTessellator * | tessellator | ) |
| virtual

Set/Get a cell tessellator if cells must be tessellated during processing.

Precondition
  tessellator_exists: tessellator!=0

## ◆ GetTessellator()

virtual vtkGenericCellTessellator* vtkGenericDataSet::GetTessellator | ( |  | ) |
| virtual

Set/Get a cell tessellator if cells must be tessellated during processing.

Precondition
  tessellator_exists: tessellator!=0

## ◆ GetActualMemorySize()

unsigned long vtkGenericDataSet::GetActualMemorySize | ( |  | ) |
| overridevirtual

Actual size of the data in kibibytes (1024 bytes); only valid after the pipeline has updated.

It is guaranteed to be greater than or equal to the memory required to represent the data.

Reimplemented from vtkDataObject.

## ◆ GetDataObjectType()

int vtkGenericDataSet::GetDataObjectType | ( |  | ) |
| overridevirtual

Return the type of data object.

Reimplemented from vtkDataObject.

## ◆ GetEstimatedSize()

virtual vtkIdType vtkGenericDataSet::GetEstimatedSize | ( |  | ) |
| pure virtual

Estimated size needed after tessellation (or special operation)

## ◆ GetData() [1/2]

static vtkGenericDataSet* vtkGenericDataSet::GetData | ( | vtkInformation * | info | ) |
| static

Retrieve an instance of this class from an information object.

## ◆ GetData() [2/2]

static vtkGenericDataSet* vtkGenericDataSet::GetData | ( | vtkInformationVector * | v,
|  | int | i = `0`
| ) |  |
| static

Retrieve an instance of this class from an information object.

## Member Data Documentation

## ◆ Attributes

vtkGenericAttributeCollection* vtkGenericDataSet::Attributes
| protected

Definition at line 281 of file vtkGenericDataSet.h.

## ◆ Tessellator

vtkGenericCellTessellator* vtkGenericDataSet::Tessellator
| protected

Definition at line 284 of file vtkGenericDataSet.h.

## ◆ Bounds

double vtkGenericDataSet::Bounds[6]
| protected

Definition at line 286 of file vtkGenericDataSet.h.

## ◆ Center

double vtkGenericDataSet::Center[3]
| protected

Definition at line 287 of file vtkGenericDataSet.h.

## ◆ ComputeTime

vtkTimeStamp vtkGenericDataSet::ComputeTime
| protected

Definition at line 288 of file vtkGenericDataSet.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkGenericDataSet.h